Subject: [IPP] Errata for PWG 5107.3: Printer MIB and IPP MFD Alerts

From: Michael Sweet <[email-masked]>
Date: Mon, 17 Mar 2014 14:07:57 -0400

All,

It was recently pointed out to me that PWG 5107.3 defines several "printer-state-reasons" keywords with the suffix "-error":

    input-media-tray-feed-error
    output-media-tray-feed-error
    media-path-input-feed-error
    media-path-output-feed-error
    scan-media-path-input-feed-error
    scan-media-path-output-feed-error
    fax-modem-protocol-error

However, RFC 2911 reserves this suffix for indicating the severity of the reason:

   4.4.12 printer-state-reasons (1setOf type2 keyword)

   This REQUIRED Printer attribute supplies additional detail about the
   device's state.  Some of the these value definitions indicate
   conformance requirements; the rest are OPTIONAL.

   Each keyword value MAY have a suffix to indicate its level of
   severity.  The three levels are: report (least severe), warning, and
   error (most severe).

      - '-report':  This suffix indicates that the reason is a "report".
        An implementation may choose to omit some or all reports. Some
        reports specify finer granularity about the printer state;
        others serve as a precursor to a warning. A report MUST contain
        nothing that could affect the printed output.
      - '-warning': This suffix indicates that the reason is a
        "warning".  An implementation may choose to omit some or all
        warnings. Warnings serve as a precursor to an error. A warning
        MUST contain nothing that prevents a job from completing, though
        in some cases the output may be of lower quality.
      - '-error': This suffix indicates that the reason is an "error".
        An implementation MUST include all errors. If this attribute
        contains one or more errors, printer MUST be in the stopped
        state.

   If the implementation does not add any one of the three suffixes, all
   parties MUST assume that the reason is an "error".

Since an IPP Printer MAY report any of the above keywords when the Printer is not in the stopped state, I propose we add an informative note to table 3 saying something like the following:

    Note 1: Section 4.4.12 [RFC2911] requires that the Printer is in the
    stopped state when reporting "printer-state-reasons" values ending
    with "-error". Printers MUST append a suffix of "-report" or
    "warning" to this keyword when the Printer is not in the stopped
    state.

I'm not sure if we want to clarify that the "job-state-reasons" attribute only contains the registered values without added suffixes.

_________________________________________________________
Michael Sweet, Senior Printing System Engineer, PWG Chair

_______________________________________________
ipp mailing list
[email-masked]
https://www.pwg.org/mailman/listinfo/ipp

---

From: Ira McDonald <[email-masked]>
Date: Mon, 17 Mar 2014 16:45:59 -0400

Hi Mike,

I suggest that we replace "-error" with "-fault" in all of these printer
state
reasons.

If the current "-error" suffix is simply removed, the meaning of these
alerts
is lost.

BTW - normally, we couldn't change these names in the PrtAlertCodeTC
textual convention in the IANA Printer MIB, because it's illegal under
SMIv2
rules to change the name of an already assigned enumeration value.

HOWEVER - *none* of the PWG 5107.3 section 9.2 updates for PrtAlertCodeTC
were ever registered with IANA - this fell through the cracks in mid-2012.

SUGGESTION - we revise/update PWG 5107.3 and change the IPP and
IANA Printer MIB names from "-error" to "-fault" (or "Error" to "Fault" in
the
MIB) and correct or submit the IANA IPP and MIB registrations.

WDYT?

Cheers,
- Ira

Ira McDonald (Musician / Software Architect)
Co-Chair - TCG Trusted Mobility Solutions WG
Chair - Linux Foundation Open Printing WG
Secretary - IEEE-ISTO Printer Working Group
Co-Chair - IEEE-ISTO PWG Internet Printing Protocol WG
IETF Designated Expert - IPP & Printer MIB
Blue Roof Music / High North Inc
http://sites.google.com/site/blueroofmusic
http://sites.google.com/site/highnorthinc
mailto: [email-masked]
Winter  579 Park Place  Saline, MI  48176  734-944-0094
Summer  PO Box 221  Grand Marais, MI 49839  906-494-2434

On Mon, Mar 17, 2014 at 2:07 PM, Michael Sweet <[email-masked]> wrote:

> All,
>
> It was recently pointed out to me that PWG 5107.3 defines several
> "printer-state-reasons" keywords with the suffix "-error":
>
> Since an IPP Printer MAY report any of the above keywords when the Printer
> is not in the stopped state, I propose we add an informative note to table
> 3 saying something like the following:
>
> I'm not sure if we want to clarify that the "job-state-reasons" attribute
> only contains the registered values without added suffixes.
>
> wims mailing list
> [email-masked]
> https://www.pwg.org/mailman/listinfo/wims
>
>

---

From: Michael Sweet <[email-masked]>
Date: Tue, 18 Mar 2014 12:58:36 -0400

Ira,

Unfortunately, I know of existing implementations for these keywords, so I don't think changing them to use "-fault" at the end is feasible.  And at least for all of the media feed keywords the "-error" suffix is likely OK - feed errors generally require user interaction, so typically the printer will be in the stopped state, meeting the requirements of RFC 2911.

An alternative is to add definitions of 'fax-modem-protocol-warning' and 'fax-modem-protocol-report' and make the other keywords exclusively report errors that stop the printer.  The IANA registration could just be for 'fax-modem-protocol' to match the other "printer-state-reasons" registrations.

On Mar 17, 2014, at 4:45 PM, Ira McDonald <[email-masked]> wrote:

> Hi Mike,
> 
> I suggest that we replace "-error" with "-fault" in all of these printer state 
> reasons.
> 
> If the current "-error" suffix is simply removed, the meaning of these alerts
> is lost.
> 
> textual convention in the IANA Printer MIB, because it's illegal under SMIv2 
> IANA Printer MIB names from "-error" to "-fault" (or "Error" to "Fault" in the